## cmake-format 0.6.13

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(tangentsky)
enable_testing()
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

if(NOT CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX
      ${CMAKE_BINARY_DIR}/install
      CACHE PATH "cmake installation directory")
endif()

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

find_package(Threads REQUIRED)
find_package(fmt QUIET)

if(EXISTS ${CMAKE_SOURCE_DIR}/build_tooling/cmake)
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/build_tooling/cmake)
endif()
# NOTE(josh): kitware documentation says that this is already the case, however
# that does not seem to be true.
list(APPEND CMAKE_MODULE_PATH /usr/share/cmake/Modules)
include(tangent)

# cmake-lint: disable=E1122
pkg_find(
  PKG eigen3
  PKG fontconfig
  PKG freetype2
  PKG fuse
  PKG glib-2.0
  PKG glibmm-2.4
  PKG gnuradio-osmosdr
  PKG gnuradio-filter
  PKG gobject-introspection-1.0
  PKG gtk+-3.0
  PKG gtkmm-3.0
  PKG libcurl
  PKG libelf
  PKG libglog
  PKG libpng NAMES libpng12 libpng16
  PKG librtlsdr
  PKG libudev
  PKG openssl
  PKG protobuf
  PKG tinyxml2
  PKG vulkan
  PKG x11-xcb)

include_directories(${CMAKE_SOURCE_DIR})

set(CMAKE_CXX_STANDARD "11")
set(CMAKE_C_STANDARD "99")
# NOTE(josh): needed to workaround some issue. I forgot what exactly.
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -rdynamic")

# Allow us to import/execute modules directly from the source tree
set(ENV{PYTHONPATH} ${CMAKE_SOURCE_DIR})
set(CTEST_ENVIRONMENT "PYTHONPATH=${CMAKE_SOURCE_DIR}")

glob_subdirs()

=== cmakelang/CMakeLists.txt ===
set(_testnames format.invocation_tests format.layout_tests lex.tests
               markup_tests parse.tests)

foreach(testname ${_testnames})
  tangent_addtest(
    NAME cmakelang-${testname}
    COMMAND python -Bm cmakelang.${testname}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endforeach()

if(NOT IS_TRAVIS_CI)
  foreach(testname ${_testnames})
    tangent_addtest(
      NAME cmakelang-${testname}_py3
      COMMAND python3 -Bm cmakelang.${testname}
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  endforeach()
endif()

set(_genfiles)
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/parse/variables.py
  COMMAND python -Bm cmakelang.tools.parse_cmake_help --outfile
          cmakelang/parse/variables.py variables
  DEPENDS tools/parse_cmake_help.py tools/variables.jinja.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "Generating variables.py")
list(APPEND _genfiles ${CMAKE_CURRENT_SOURCE_DIR}/parse/variables.py)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/parse/properties.py
  COMMAND python -Bm cmakelang.tools.parse_cmake_help --outfile
          cmakelang/parse/properties.py properties
  DEPENDS tools/parse_cmake_help.py tools/properties.jinja.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "Generating properties.py")
list(APPEND _genfiles ${CMAKE_CURRENT_SOURCE_DIR}/parse/properties.py)

add_custom_target(gen-cmakelang DEPENDS ${_genfiles})
add_dependencies(gen gen-cmakelang)

# NOTE(josh): this is just here to induce a dependency on the configure step. If
# we change the version number in __init__.py we need to re-run cmake so we can
# get out the version number and create rules for the distribution files.
configure_file(__init__.py init.stamp COPYONLY)

check_pyoneline(
  "from __future__ import print_function" #
  "import cmakelang" #
  "print(cmakelang.__version__)" #
  OUTPUT_VARIABLE _src_version)

check_pyoneline(
  "from __future__ import print_function" #
  "import cmakelang" #
  "from packaging import version" #
  "print(version.parse(cmakelang.__version__).is_devrelease)"
  OUTPUT_VARIABLE _is_devrelease)

# NOTE(josh): python uses dot to separate pre-release while node uses dash
string(REGEX REPLACE "([0-9]+\\.[0-9]+\\.[0-9]+)\\.(.*)" "\\1-\\2"
                     _extension_version "${_src_version}")

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/.egg
  COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/.egg
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

set(_python_packages cmakelang cmake_annotate cmake_format cmake_lint
                     cmake_parse)

set(_distdir ${CMAKE_CURRENT_BINARY_DIR}/dist)
foreach(package ${_python_packages})
  string(REPLACE "_" "-" dashpackage "${package}")
  set(_pypi_artifacts_${package}
      ${_distdir}/${dashpackage}-${_src_version}.tar.gz
      ${_distdir}/${package}-${_src_version}-py3-none-any.whl)
  list(APPEND _pypi_artifacts ${_pypi_artifacts_${package}})
endforeach()

add_custom_command(
  OUTPUT ${_pypi_artifacts}
  COMMAND
    # cmake-format: off
    python cmakelang/pypi/setup.py
    build --build-base ${CMAKE_CURRENT_BINARY_DIR}
    egg_info --egg-base ${CMAKE_CURRENT_BINARY_DIR}/.egg
    bdist_wheel
      --bdist-dir ${CMAKE_CURRENT_BINARY_DIR}/bdist
      --dist-dir ${_distdir}
    sdist --dist-dir ${_distdir}
    # cmake-format: on
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/.egg
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

add_custom_target(
  cmakelang-wheel
  DEPENDS ${_distdir}/cmakelang-${_src_version}-py3-none-any.whl)
add_dependencies(wheels cmakelang-wheel)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.rst
  DEPENDS doc/release_notes.rst ${TANGENT_TOOLING}/get_release_notes.py
  COMMAND
    # cmake-format: off
    python -B ${TANGENT_TOOLING}/get_release_notes.py
      ${CMAKE_CURRENT_SOURCE_DIR}/doc/release_notes.rst ${_src_version}
      -o ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.rst
    # cmake-format: on
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

set(_releasenote_path
    ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.md)
add_custom_command(
  OUTPUT ${_releasenote_path}
  COMMAND pandoc -s -o ${_releasenote_path}
          ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.rst
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/release_notes-${_src_version}.rst
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

set(_keydir ${CMAKE_SOURCE_DIR}/tangent/tooling/deploy_keys)
set(_docker_keyid "eadc5618fa58")
set(_precommit_keyid "616260d3147f")

foreach(slug docker precommit)
  unset(_${slug}_deploykey)
  set(_outfile ${CMAKE_CURRENT_BINARY_DIR}/cmakelang-${slug}.deploy_key)
  get_filename_component(_${slug}_deploykey ${_outfile} ABSOLUTE)
  travis_decrypt(${_outfile} ${_keydir}/cmakelang-${slug}.enc ${_${slug}_keyid})
endforeach()

glob_subdirs()

add_custom_target(
  push-cmakelang-github-pseudorelease-tag
  COMMAND python -B ${TANGENT_TOOLING}/github.py create-pseudorelease-tag
          cheshirekow/cmake_format \$\${TRAVIS_BRANCH}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "Pushing psuedo-release tag")

set(_vscedir ${CMAKE_CURRENT_BINARY_DIR}/vscode_extension)
add_custom_target(
  push-cmakelang-github-release
  DEPENDS ${_releasenote_path} ${_pypi_artifacts}
          # ${_vscedir}/cmake-format-${_extension_version}.vsix
  COMMAND
    # cmake-format: off
    python -B ${TANGENT_TOOLING}/github.py push-release
      --message ${_releasenote_path}
      --repo-slug cheshirekow/cmake_format
      --tag "v${_src_version}"
      ${_distdir}/cmakelang-${_src_version}.tar.gz
      ${_distdir}/cmakelang-${_src_version}-py3-none-any.whl
      ${_vscedir}/cmake-format-${_extension_version}.vsix
    # cmake-format: on
  COMMENT "Uploading release artifacts"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

# NOTE(josh): cmake is broken. It fails to produce an accurate build system when
# we correctly specify the .vsix path in the above rule. We must use target
# level dependencies to get the correct order of operations and then omit the
# actual file-level dependency.
add_dependencies(push-cmakelang-github-release vscode-extension)

travis_decrypt(${CMAKE_CURRENT_BINARY_DIR}/pypi-tokens.json
               ${_keydir}/cmakelang-pypi-tokens.json.enc "db380b4cb002")

foreach(package ${_python_packages})
  unset(_twineargs)
  if(_is_devrelease)
    list(APPEND _twineargs --repository testpypi)
  endif()

  unset(_twinedeps)
  if(IS_TRAVIS_CI)
    set(_pypirc ${CMAKE_CURRENT_BINARY_DIR}/pypirc-${package})
    list(APPEND _twineargs --config-file ${_pypirc})
    list(APPEND _twinedeps ${_pypirc})

    add_custom_command(
      OUTPUT ${_pypirc}
      DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/pypi-tokens.json
              ../tangent/tooling/write_pypirc.py
      COMMAND
        python -Bm tangent.tooling.write_pypirc #
        --outfile ${_pypirc} #
        --tokens-from ${CMAKE_CURRENT_BINARY_DIR}/pypi-tokens.json #
        --package ${package}
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      COMMENT "Writing ${_pypirc}")
  endif()

  add_custom_target(
    push-cmakelang-pypi-${package}
    DEPENDS ${_pypi_artifacts_${package}} ${_twinedeps}
    COMMAND twine upload --skip-existing ${_twineargs}
            ${_pypi_artifacts_${package}}
    COMMENT "Uploading ${package} to pypi"
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endforeach()

add_custom_target(push-cmakelang-pypi-release)
add_dependencies(push-cmakelang-pypi-release push-cmakelang-pypi-cmakelang
                 push-cmakelang-pypi-cmake_format)

add_custom_target(
  push-cmakelang-precommit
  DEPENDS ${_precommit_deploykey}
  COMMAND
    python -B ${CMAKE_CURRENT_SOURCE_DIR}/tools/ensure_precommit_tag.py
    --version ${_src_version} --deploykey ${_precommit_deploykey} --workdir
    ${CMAKE_CURRENT_BINARY_DIR}/precommit-scratch
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "Pushing precommit release tag")

add_custom_target(
  push-cmakelang-docker
  DEPENDS ${_docker_deploykey}
  COMMAND
    python -B ${CMAKE_CURRENT_SOURCE_DIR}/tools/ensure_docker_tag.py --version
    ${_src_version} --deploykey ${_docker_deploykey} --workdir
    ${CMAKE_CURRENT_BINARY_DIR}/docker-scratch
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "Pushing docker release tag")

set(_release_targets
    push-cmakelang-github-release push-cmakelang-rtd-repo
    push-cmakelang-pypi-release push-cmakelang-precommit push-cmakelang-docker)

add_custom_target(release-cmakelang)
add_dependencies(release-cmakelang ${_release_targets})

# foreach(target ${_release_targets}) add_dependencies(${target} best-test)
# endforeach()

=== tangent/CMakeLists.txt ===
glob_subdirs()

=== cmakelang/command_tests/CMakeLists.txt ===
set(MODPREFIX cmakelang.command_tests)

set(_testnames
    TestAddCustomCommand
    TestAddExecutableCommand
    TestAddLibraryCommand
    TestConditional
    TestExport
    TestFile
    TestForeach
    TestInstall
    TestMiscFormatting
    TestSetTargetProperties
    TestSet)

foreach(testname ${_testnames})
  tangent_addtest(
    NAME cmakelang-${testname}
    COMMAND python -Bm ${MODPREFIX} ${testname}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endforeach()

if(NOT IS_TRAVIS_CI)
  foreach(testname ${_testnames})
    tangent_addtest(
      NAME cmakelang-${testname}_py3
      COMMAND python3 -Bm ${MODPREFIX} ${testname}
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  endforeach()
endif()

=== cmakelang/contrib/CMakeLists.txt ===
tangent_addtest(
  NAME cmakelang-validate-pullrequest
  COMMAND python -Bm cmakelang.contrib.validate_pullrequest
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

tangent_addtest(
  NAME cmakelang-validate-database
  COMMAND python -Bm cmakelang.contrib.validate_database
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== cmakelang/doc/CMakeLists.txt ===
#
# Generated source bits for sphinx documentation
#
set(_stage ${CMAKE_CURRENT_BINARY_DIR}/stage)
set(_genbits)

add_custom_command(
  OUTPUT ${_stage}/bits
  COMMAND ${CMAKE_COMMAND} -E make_directory ${_stage}/bits
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "Creating directory ${_stage}/bits")

set(_config_deps ../configuration.py #
                 ../config_util.py)

add_custom_command(
  OUTPUT ${_stage}/bits/format-usage.txt
  COMMAND python -Bm cmakelang.format --help > ${_stage}/bits/format-usage.txt
  DEPENDS ${_stage}/bits #
          ${_config_deps}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/format-usage.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/format-usage-short.txt ${_stage}/bits/common-usage.txt
  COMMAND python -Bm cmakelang.tools.split_help ${_stage}/bits/format-usage.txt
          ${_stage}/bits/format-usage-short.txt ${_stage}/bits/common-usage.txt
  DEPENDS ${_stage}/bits/format-usage.txt ../tools/split_help.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/format-usage-short.txt
     ${_stage}/bits/common-usage.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/annotate-usage.txt
  COMMAND python -Bm cmakelang.annotate --help >
          ${_stage}/bits/annotate-usage.txt
  DEPENDS ${_stage}/bits #
          ${_config_deps} ../annotate.py #
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/annotate-usage.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/ctest-to-usage.txt
  COMMAND python -Bm cmakelang.ctest_to --help >
          ${_stage}/bits/ctest-to-usage.txt
  DEPENDS ${_stage}/bits #
          ${_config_deps} ../ctest_to.py #
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/ctest-to-usage.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/lint-usage.txt
  COMMAND python -Bm cmakelang.lint --help > ${_stage}/bits/lint-usage.txt
  DEPENDS ${_stage}/bits #
          ${_config_deps} #
          ../lint/__main__.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/lint-usage.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/lint-usage-short.txt
  COMMAND python -Bm cmakelang.tools.split_help ${_stage}/bits/lint-usage.txt
          ${_stage}/bits/lint-usage-short.txt
  DEPENDS ${_stage}/bits/lint-usage.txt ../tools/split_help.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/lint-usage-short.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/configbits.py
  COMMAND python -Bm cmakelang.format --dump-config >
          ${_stage}/bits/configbits.py
  DEPENDS ${_stage}/bits #
          ${_config_deps}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/configbits.py)

add_custom_command(
  OUTPUT ${_stage}/bits/lint-in.cmake
  COMMAND ${CMAKE_COMMAND} -E copy cmakelang/lint/test/expect_lint.cmake
          ${_stage}/bits/lint-in.cmake
  DEPENDS ${_stage}/bits #
          ${CMAKE_SOURCE_DIR}/cmakelang/lint/test/expect_lint.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/lint-in.cmake)

add_custom_command(
  OUTPUT ${_stage}/bits/lint-out.cmake
  COMMAND python -Bm cmakelang.lint cmakelang/lint/test/expect_lint.cmake >
          ${_stage}/bits/lint-out.cmake || echo "OK"
  DEPENDS ${_stage}/bits #
          ../lint/__main__.py #
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/lint-out.cmake)

add_custom_command(
  OUTPUT ${_stage}/bits/dump-example-src.cmake
  COMMAND ${CMAKE_COMMAND} -E copy cmakelang/doc/bits/dump-example.cmake
          ${_stage}/bits/dump-example-src.cmake
  DEPENDS ${_stage}/bits #
          bits/dump-example.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/dump-example-src.cmake)

add_custom_command(
  OUTPUT ${_stage}/bits/dump-example-lex.txt
  COMMAND
    python -Bm cmakelang.format --dump lex ${_stage}/bits/dump-example-src.cmake
    > ${_stage}/bits/dump-example-lex.txt
  DEPENDS ${_stage}/bits #
          ../format/__main__.py #
          ${_stage}/bits/dump-example-src.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/dump-example-lex.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/dump-example-parse.txt
  COMMAND
    python -Bm cmakelang.format --dump parse
    cmakelang/doc/bits/dump-example.cmake >
    ${_stage}/bits/dump-example-parse.txt
  DEPENDS ${_stage}/bits #
          ../format/__main__.py #
          ${_stage}/bits/dump-example-src.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/dump-example-parse.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/dump-example-layout.txt
  COMMAND
    python -Bm cmakelang.format --dump layout
    cmakelang/doc/bits/dump-example.cmake >
    ${_stage}/bits/dump-example-layout.txt
  DEPENDS ${_stage}/bits #
          ../format/__main__.py #
          ${_stage}/bits/dump-example-src.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/dump-example-layout.txt)

add_custom_command(
  OUTPUT ${_stage}/bits/example-in.cmake
  COMMAND ${CMAKE_COMMAND} -E copy cmakelang/format/testdata/test_in.cmake
          ${_stage}/bits/example-in.cmake
  DEPENDS ${_stage}/bits #
          ../format/testdata/test_in.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/example-in.cmake)

add_custom_command(
  OUTPUT ${_stage}/bits/example-out.cmake
  COMMAND ${CMAKE_COMMAND} -E copy cmakelang/format/testdata/test_out.cmake
          ${_stage}/bits/example-out.cmake
  DEPENDS ${_stage}/bits #
          ../format/testdata/test_out.cmake
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/example-out.cmake)

add_custom_command(
  OUTPUT ${_stage}/bits/lintimpl-table.rst
  COMMAND python -Bm cmakelang.lint.gendocs table >
          ${_stage}/bits/lintimpl-table.rst
  DEPENDS ${_stage}/bits #
          ../lint/lintdb.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/lintimpl-table.rst)

add_custom_command(
  OUTPUT ${_stage}/bits/features.rst
  COMMAND tail -n +5 cmakelang/doc/format-features.rst >
          ${_stage}/bits/features.rst
  DEPENDS ${_stage}/bits #
          format-features.rst
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/bits/features.rst)

add_custom_command(
  OUTPUT ${_stage}/lint-implemented.rst
  COMMAND python -Bm cmakelang.lint.gendocs reference >
          ${_stage}/lint-implemented.rst
  DEPENDS ${_stage}/bits #
          ../lint/lintdb.py ../lint/gendocs.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/lint-implemented.rst)

add_custom_command(
  OUTPUT ${_stage}/example_rendered.html
  COMMAND
    python -Bm cmakelang.annotate --format iframe
    cmakelang/format/testdata/test_out.cmake > ${_stage}/example_rendered.html
  DEPENDS ${_stage}/bits #
          ../annotate.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/example_rendered.html)

add_custom_command(
  OUTPUT ${_stage}/configopts.rst
  COMMAND python -Bm cmakelang.tools.gen_config_details >
          ${_stage}/configopts.rst
  DEPENDS ../config_util.py #
          ../configuration.py #
          ../tools/gen_config_details.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/configopts.rst)

# TODO(josh): remove this iteration for just one file.
set(_genfiles)
set(_insource_genfiles README.rst)
foreach(genfile ${_insource_genfiles})
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
    COMMAND python -B ${TANGENT_TOOLING}/gendoc.py --bits ${_stage}/bits
            ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
    # TODO(josh): not every file depends on every bit, so this is overkill, but
    # whatever... it's fine for now. We'll need more complicated code if we want
    # to actually declare which bits each file depends on.
    DEPENDS ${_genbits} ${TANGENT_TOOLING}/gendoc.py
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  list(APPEND _genfiles ${CMAKE_CURRENT_SOURCE_DIR}/${genfile})

  tangent_addtest(
    NAME cmakelang-doc-verify-${genfile} DEPENDS
                                         ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
    COMMAND python -B ${TANGENT_TOOLING}/gendoc.py --verify --bits
            ${_stage}/bits ${CMAKE_CURRENT_SOURCE_DIR}/${genfile}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endforeach()
add_custom_target(genbits-cmakelang DEPENDS ${_genbits})
add_dependencies(test-deps genbits-cmakelang)
add_custom_target(genfiles-cmakelang DEPENDS ${_genfiles})
add_dependencies(gen genfiles-cmakelang)

# copy sourcefiles from the sourcetree into the build tree so that they're all
# accessible from one tree
set(_copyfiles)
set(_docsources
    .readthedocs.yml
    bits/dump-example.cmake
    changelog.rst
    cmake-annotate.rst
    cmake-format.rst
    cmake-lint.rst
    configuration.rst
    conf.py
    contributing.rst
    ctest-to.rst
    custom_parsers.rst
    format-algorithm.rst
    format-case_studies.rst
    format-example.rst
    format-features.rst
    format-usage.rst
    index.rst
    installation.rst
    lint-example.rst
    lint-inline.rst
    lint-notes.rst
    lint-summary.rst
    lint-usage.rst
    modules.rst
    parse-algorithm.rst
    parse-automatic.rst
    parse-tree.rst
    release_notes.rst
    release_process.rst
    release-pipeline.svg)
foreach(docsource ${_docsources})
  add_custom_command(
    OUTPUT ${_stage}/${docsource}
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/${docsource}
            ${_stage}/${docsource}
    DEPENDS ${docsource} ${_stage}/bits)
  list(APPEND _copyfiles ${_stage}/${docsource})
endforeach()

# For the subproject build, also copy some of the common files into the build
# tree.
add_custom_command(
  OUTPUT ${_stage}/conf_common.py
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/doc/conf.py
          ${_stage}/conf_common.py)
list(APPEND _copyfiles ${_stage}/conf_common.py)

add_custom_command(
  OUTPUT ${_stage}/sphinx-static/css/cheshire_theme.css
  COMMAND
    ${CMAKE_COMMAND} -E copy
    ${CMAKE_SOURCE_DIR}/doc/sphinx-static/css/cheshire_theme.css
    ${_stage}/sphinx-static/css/cheshire_theme.css
  DEPENDS ${_stage}/bits)
list(APPEND _copyfiles ${_stage}/sphinx-static/css/cheshire_theme.css)

add_custom_command(
  OUTPUT ${_stage}/rtd-requirements.txt
  COMMAND
    python -B ${TANGENT_TOOLING}/gen_rtd_requirements.py --tag from-travis
    --version ${_src_version} -o ${_stage}/rtd-requirements.txt
    ${CMAKE_CURRENT_SOURCE_DIR}/rtd-requirements.txt.in
  DEPENDS ${TANGENT_TOOLING}/gen_rtd_requirements.py
          ${CMAKE_CURRENT_SOURCE_DIR}/rtd-requirements.txt.in
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
list(APPEND _genbits ${_stage}/rtd-requirements.txt)

set(_sphinx_manifest ${_genbits} ${_copyfiles})
list(SORT _sphinx_manifest)

# NOTE(josh): cmake 3.10 does not have list(JOIN)
string(REPLACE ";" "\n" _manifest_text "${_sphinx_manifest}")

# NOTE(josh): don't use file(WRITE) because that wont create a dependency on the
# configure step to rerun cmake if the file is missing
configure_file(MANIFEST.in ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST
               NEWLINE_STYLE UNIX)

add_custom_target(
  clean-cmakelang-sphinx-stage
  DEPENDS ${_sphinx_manifest} ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST
  COMMAND python -B ${TANGENT_TOOLING}/clean_stage.py
          ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST ${_stage}
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "Cleaning cmakelang/doc/stage")

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/html/index.html
  COMMAND env PYTHONPATH=${CMAKE_SOURCE_DIR} sphinx-build -M html ${_stage}
          ${CMAKE_CURRENT_BINARY_DIR}
  COMMAND touch ${CMAKE_CURRENT_BINARY_DIR}/html/index.html
  DEPENDS clean-cmakelang-sphinx-stage ${_sphinx_manifest}
          ${CMAKE_CURRENT_BINARY_DIR}/MANIFEST ${CMAKE_SOURCE_DIR}/doc/conf.py
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}

=== cmakelang/lint/CMakeLists.txt ===
set(_genfiles ${CMAKE_CURRENT_SOURCE_DIR}/test/expect_lint.cmake
              ${CMAKE_CURRENT_SOURCE_DIR}/test/lint_tests.cmake)
add_custom_command(
  OUTPUT ${_genfiles}
  COMMAND python -Bm cmakelang.lint.test.genfiles
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
add_custom_target(cmakelang-lint-test-genfiles DEPENDS ${_genfiles})
add_dependencies(gen cmakelang-lint-test-genfiles)

foreach(testcase TestFormatFiles ConfigTestCase LintTests)
  tangent_addtest(
    NAME cmakelang-lint-${testcase}
    COMMAND python -Bm cmakelang.lint.test ${testcase}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endforeach()

=== cmakelang/test/CMakeLists.txt ===
tangent_addtest(
  NAME cmakelang-versionnumber-test
  COMMAND python -Bm cmakelang.test.version_number_test
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

tangent_addtest(
  NAME cmakelang-command-db-test
  COMMAND python -Bm cmakelang.test.command_db_test
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== cmakelang/vscode_extension/CMakeLists.txt ===
set(_copysrcs
    CHANGELOG.md
    images/cmake-format-logo.png
    images/small_demo.gif
    LICENSE
    package.json
    package-lock.json
    README.md
    src/extension.ts
    tsconfig.json
    tslint.json)

set(_copyfiles)
foreach(filename ${_copysrcs})
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${filename}
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/${filename}
            ${CMAKE_CURRENT_BINARY_DIR}/${filename}
    DEPENDS ${filename}
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  list(APPEND _copyfiles ${CMAKE_CURRENT_BINARY_DIR}/${filename})
endforeach()

# TODO(josh): glob the output tree so we can catch changes and accidental
# deletions
add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/npm_install.stamp
  COMMAND npm install
  COMMAND touch npm_install.stamp
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS ${_copyfiles} package.json package-lock.json)

set(_baseImagesUrl "https://raw.githubusercontent.com/cheshirekow")
set(_baseImagesUrl "${_baseImagesUrl}/cmakelang/master/cmakelang")
set(_baseImagesUrl "${_baseImagesUrl}/vscode_extension")

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/cmake-format-${_extension_version}.vsix
  COMMAND ${CMAKE_CURRENT_BINARY_DIR}/node_modules/vsce/out/vsce package
          --baseImagesUrl ${_baseImagesUrl}
  DEPENDS ${_copyfiles} ${CMAKE_CURRENT_BINARY_DIR}/npm_install.stamp
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

add_custom_target(
  vscode-extension
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/cmake-format-${_extension_version}.vsix)

=== tangent/tooling/CMakeLists.txt ===
add_custom_target(
  update-export
  COMMAND python -B ${TANGENT_TOOLING}/export_sparse_subrepo.py update
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "Updating sparse export")

add_custom_target(
  verify-export
  COMMAND python -B ${TANGENT_TOOLING}/export_sparse_subrepo.py verify
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  COMMENT "verify sparse export")

add_test(
  NAME verify-export
  COMMAND python -B ${TANGENT_TOOLING}/export_sparse_subrepo.py verify
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

set(_build_scripts
    broadway_run.py
    check_pbuilderrc.py
    clean_stage.py
    cmake_post.py
    debhelp.py
    export_sparse_subrepo.py
    generate_style_manifest.py
    get_release_notes.py
    get_version_from_header.py
    github.py
    gtkdoc_helper.py
    install_debug_symbols.py
    vscode_varsub.py)

set(_cmake_modules
    codestyle.cmake
    ctest_helpers.cmake
    debian.cmake
    doctools.cmake
    environment.cmake
    pkgconfig.cmake
    re2-config.cmake
    wrappers.cmake)
unset(_cmake_modules_fullpaths)
foreach(module ${_cmake_modules})
  list(APPEND _cmake_modules_fullpaths ${TANGENT_MODULES_DIR}/${module})
endforeach()

install(FILES ${CMAKE_SOURCE_DIR}/build_tooling/cmake/tangent.cmake
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/Modules")

install(FILES ${_build_scripts} ${_cmake_modules_fullpaths}
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/Modules/tangent")

=== debian/changelog ===
cmake-format (0.6.13-7) unstable; urgency=medium

  * Backport upstream PR #353 which drops the requirement for python3-six.
    Thanks to Alexandre Detiste (Closes: #1110560)
  * Update to debhelper 13. No changes required.
  * Update to standards-version 4.7.2. No changes required.

 -- Ian Campbell <ijc@debian.org>  Mon, 11 Aug 2025 14:09:23 +0100

cmake-format (0.6.13-6) unstable; urgency=medium

  * Drop unnecessary/unused dependency on python3-pkg-resources
    (Closes: #1083340).

 -- Ian Campbell <ijc@debian.org>  Sun, 06 Oct 2024 13:54:37 +0100

cmake-format (0.6.13-5) unstable; urgency=medium

  * Add DEP-3 Forwarded tags to all patches.

 -- Ian Campbell <ijc@debian.org>  Sun, 27 Aug 2023 10:00:53 +0100

cmake-format (0.6.13-4) unstable; urgency=medium

  * Depend on newer dh-python in order to remove *.egg-info in clean
    (Closes: #1043743).

 -- Ian Campbell <ijc@debian.org>  Sat, 26 Aug 2023 11:58:53 +0100

cmake-format (0.6.13-3) unstable; urgency=medium

  * Update to support Python 3.11 (Closes: #1028176)
  * Update Standards Version (no changes required)

 -- Ian Campbell <ijc@debian.org>  Sun, 08 Jan 2023 09:17:35 +0000

cmake-format (0.6.13-2) unstable; urgency=medium

  * Correct typos in manpage/command line options and whatis entry of manpages.
  * Add a debian/watch file.

 -- Ian Campbell <ijc@debian.org>  Sun, 04 Oct 2020 15:56:05 +0100

cmake-format (0.6.13-1) unstable; urgency=medium

  * New upstream release.
  * Disable TestCommandDatabase test (Closes: #971117).

 -- Ian Campbell <ijc@debian.org>  Fri, 02 Oct 2020 20:18:14 +0100

=== debian/control ===
Source: cmake-format
Maintainer: Ian Campbell <ijc@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python (>= 6.20230825),
               dh-sequence-python3,
               cmake,
               python3,
               python3-setuptools,
               python3-argparse-manpage
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/cmake_format
Vcs-Git: https://salsa.debian.org/debian/cmake_format.git
Homepage: https://github.com/cheshirekow/cmake_format
Rules-Requires-Root: no

Package: cmake-format
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
Recommends: python3-jinja2, python3-argcomplete
Description: source code formatter for cmake listfiles
 Contains several utilities for formatting and linting cmake
 configuration files.
 .
  * cmake-annotate can generate pretty HTML from your
    listfiles.
  * cmake-format can format your listfiles nicely.
  * cmake-lint can check your listfiles for problems

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/cmakeformat-$1\.tar\.gz/ \
  https://github.com/cheshirekow/cmake_format/tags .*/v?(\d\S+)\.tar\.gz
